import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.table.*;
import javax.swing.event.*;
import java.beans.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

import CH.psi.midas.*;

public class JPanelHistory extends javax.swing.JPanel
{
    // Member variables
    private Experiment experiment;
    private Vector histPanel = new Vector();
    
	public JPanelHistory()
	{

		//{{INIT_CONTROLS
		setLayout(new BorderLayout(0,0));
		Insets ins = getInsets();
		setSize(430,270);
		JPanel1.setLayout(new GridBagLayout());
		add(BorderLayout.WEST, JPanel1);
		JPanel1.setBounds(0,0,41,270);
		JButton1.setText("1");
		JButton1.setActionCommand("1");
		JPanel1.add(JButton1, new com.symantec.itools.awt.GridBagConstraintsD(0,0,1,1,0.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.NONE,new Insets(0,0,0,0),0,0));
		JButton1.setBounds(0,0,41,25);
		JButton2.setText("2");
		JButton2.setActionCommand("2");
		JPanel1.add(JButton2, new com.symantec.itools.awt.GridBagConstraintsD(0,1,1,1,0.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.NONE,new Insets(0,0,0,0),0,0));
		JButton2.setBounds(0,25,41,25);
		JButton4.setText("4");
		JButton4.setActionCommand("4");
		JPanel1.add(JButton4, new com.symantec.itools.awt.GridBagConstraintsD(0,2,1,1,0.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.NONE,new Insets(0,0,0,0),0,0));
		JButton4.setBounds(0,50,41,25);
		JPanel3.setLayout(new FlowLayout(FlowLayout.CENTER,5,5));
		JPanel1.add(JPanel3, new com.symantec.itools.awt.GridBagConstraintsD(0,4,1,1,0.0,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.BOTH,new Insets(0,0,0,0),0,0));
		JPanel3.setBounds(0,75,41,195);
		JPanel2.setLayout(new GridLayout(0,2,0,0));
		add(BorderLayout.CENTER,JPanel2);
		JPanel2.setBounds(41,0,389,270);
		//}}

		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		JButton1.addActionListener(lSymAction);
		JButton2.addActionListener(lSymAction);
		JButton4.addActionListener(lSymAction);
		//}}
	}

	//{{DECLARE_CONTROLS
	javax.swing.JPanel JPanel1 = new javax.swing.JPanel();
	javax.swing.JButton JButton1 = new javax.swing.JButton();
	javax.swing.JButton JButton2 = new javax.swing.JButton();
	javax.swing.JButton JButton4 = new javax.swing.JButton();
	javax.swing.JPanel JPanel3 = new javax.swing.JPanel();
	javax.swing.JPanel JPanel2 = new javax.swing.JPanel();
	//}}

    
  public void connect(Experiment experiment) throws 
                  IOException,OdbKeyNotFoundException,TooManyListenersException {
    this.experiment = experiment;

    OdbKey odbKey;

    // create default history if not existing
    try {
      odbKey = new OdbKey(experiment, "/History/Display/Panel0");
    } catch (OdbKeyNotFoundException e) {
      odbKey = new OdbKey(experiment, "/History/Display/Panel0", OdbKey.TID_STRING);
      odbKey.setTextAt("System / Trigger per sec.", 0, 64);
    }

    // determine number of panels
    int numPanels;
    for (numPanels=0 ; ; numPanels++) {
      try {  
        odbKey = new OdbKey(experiment, "/History/Display/Panel"+numPanels);
      } catch (OdbKeyNotFoundException e) { break; }
    }

    if (numPanels == 1)
      JPanel2.setLayout(new GridLayout(0,1,0,0));
    else
      JPanel2.setLayout(new GridLayout(0,2,0,0));

    // loop over all panels
    for (int i=0 ; ; i++) {
        
      try {  
        odbKey = new OdbKey(experiment, "/History/Display/Panel"+i);
      } catch (OdbKeyNotFoundException e) { break; }
        
      // create history panel and connect it to experiment  
      MJHist h = new MJHist();

      // add panel to frame
      JPanel2.add(h);
      
      // connect panel
      h.connect(experiment, odbKey);
      
      // save panel in list
      histPanel.addElement(h);
    }
  }
    

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == JButton1)
				setNumPanels(1);
			else if (object == JButton2)
				setNumPanels(2);
			else if (object == JButton4)
				setNumPanels(4);
		}
	}

  void setNumPanels(int numPanels)
  {
    // remove panels from pane
    JPanel2.removeAll();
    
    // remove panels
    for (int i=histPanel.size()-1 ; i>=numPanels ; i--) {
      MJHist h = (MJHist)histPanel.elementAt(i);
      h.disconnect();
      histPanel.removeElementAt(i);
      try {
        h.getOdbKey().deleteKey();
      } catch (IOException e) {}
    }
    
    // add panels
    for (int i=histPanel.size() ; i<numPanels ; i++) {

      try {
      
        // init ODB key
        OdbKey odbKey;
        try {
          odbKey = new OdbKey(experiment, "/History/Display/Panel"+i);
        } catch (OdbKeyNotFoundException e) {
          odbKey = new OdbKey(experiment, "/History/Display/Panel"+i, OdbKey.TID_STRING);
          odbKey.setTextAt("", 0, 64);
        }
      
        // create history panel and connect it to experiment  
        MJHist h = new MJHist();

        // connect panel
        h.connect(experiment, odbKey);
      
        // save panel in list
        histPanel.addElement(h);
        
      } catch (Exception e) { System.out.println(e); }
    }

    // add panels back to pane
    if (numPanels == 1)
      JPanel2.setLayout(new GridLayout(0,1,0,0));
    else
      JPanel2.setLayout(new GridLayout(0,2,0,0));
    
    for (int i=0 ; i<histPanel.size() ; i++) {
      MJHist h = (MJHist)histPanel.elementAt(i);
      JPanel2.add(h);
    }
    
    JPanel2.validate();
  }
}
