// -*- C++ -*-
//
// camtest.c
// example code
//
// Author:  Mitsuhiro YAMAGA (yamaga@post.kek.jp)
// Created: Tue Sep 25 22:32:13 JST 2001
//
// $Id: testpulse.cc,v 1.1 2002/08/29 14:45:42 yamaga Exp $
//
// Revision History
//
// $Log: testpulse.cc,v $
// Revision 1.1  2002/08/29 14:45:42  yamaga
// Initial version.
//
//

#include <iostream>
#include <iomanip>
#include "k2917/K2917.h"

////
#define  DEBUG  1

//
static const unsigned int K2917_BASEADDR = 0xff00;
static K2917 kcam( K2917_BASEADDR );

////
int
main( int argc, char* argv[] )
{
  int camN, camA, camF;
  //unsigned short charge,gate;
  unsigned int charge,gate;

  if( argc < 4 ){
    std::cerr << "usage : " << argv[0] << " camN charge gate" << std::endl;
    return( 1 );
  }
  
  camN = atoi( argv[1] );
  charge = (unsigned int)strtol( argv[2], NULL, 0 );
  gate = (unsigned int)strtol( argv[3], NULL, 0 );
  //charge = atoi( argv[2] );
  //gate = atoi( argv[3] );

  // init
  kcam.camac_init();

  // charge
  camA = 0;
  camF = 16;
  kcam.camac( NAF( camN, camA, camF ), &charge );
  std::cout << "camac ret=0x" 
            << std::hex << std::setw(8) << std::setfill('0')
            << charge << std::endl;

  // gete
  camA = 2;
  kcam.camac( NAF( camN, camA, camF ), &gate );
  std::cout << "camac ret=0x" 
            << std::hex << std::setw(8) << std::setfill('0')
            << gate << std::endl;

  return( 0 );
}


