// -*- C++ -*-
//
// GsimDetView.cc
// Drawing function
//
// Author:  Mitsuhiro YAMAGA (yamaga@post.kek.jp)
// Created: Thu Jul 12 15:12:46 JST 2001
//
// $Id: GsimDetView.cc,v 1.1.1.1 2002/08/13 12:48:08 kensh Exp $
//
// Revision History
//
// $Log: GsimDetView.cc,v $
// Revision 1.1.1.1  2002/08/13 12:48:08  kensh
//
//
// Start version.
//
//
#include <iostream>
#include "ccfortran/ccfortran.h"
#include "ccfortran/G321Common.h"


//////
int    isGxsim       = 1; // set to 0 in GsimMain.cc

// FFkey
int    disp_2buf     = 0;
float  disp_zoom[]   = {1,1};
float  disp_center[] = {0,0};
float  disp_rotth    = 0;
float  disp_rotph    = 0;
float  disp_rotps    = 0;


//////
void
GsimDetView( int iview )
{
  if ( gcflag_.ISWIT[3-1] > 0 )
    std::cerr << "GsimDetView" << std::endl; 

  //
  if ( !isGxsim ) // Gxsim opens a display by itself.
    GDOPEN( 1 );

  //
  GSATT( "*","SEEN", 1 );
  GSATT( "MOTH","SEEN", 0 );
  GSATT( "CSI ","SEEN", 0 );
  GSATT( "CSH1","SEEN", 0 );
  GSATT( "CSH2","SEEN", 0 );
  GSATT( "CC03","SEEN", 0 );
  GSATT( "CC*S","SEEN", 0 );
  GSATT( "CC*W","SEEN", 0 );

  if ( iview == 4 )
    GDRAW( "MOTH", disp_rotth,disp_rotph,disp_rotps, 10,10, 1,1 );
  else if ( iview == 3 ){
#if 0
    GSATT( "FBA1","SEEN", 0 );
    GSATT( "FBA2","SEEN", 0 );
    GSATT( "FBAB","SEEN", 0 );
    GSATT( "CSCY","SEEN", 0 );
    GSATT( "CHV1","SEEN", 0 );
    GSATT( "CHV2","SEEN", 0 );
    GSATT( "CHV3","SEEN", 0 );
    GSATT( "CHV4","SEEN", 0 );
    GSATT( "CC01","SEEN", 0 );
    GSATT( "CC02","SEEN", 0 );
    GSATT( "CC04","SEEN", 0 );
    GSATT( "CC05","SEEN", 0 );
    GSATT( "BMCT","SEEN", 0 );
    GDRAW( "MOTH", 0,180,0, 10,10, 1,1 );
#endif
    GSATT( "CSCY","SEEN", 0 );
    GSATT( "CHV4","SEEN", 0 );
    GDRAWC( "MOTH", iview, 610, 10,10, 1,1 );
  }
  else
    GDRAWC( "MOTH", iview, 0, 10,10, 1,1 );

  GDCLOS();
  
  if ( isGxsim ){
    GDZOOM( 1, 1, 10,10, 10,10 );
  }
  else{
    GDZOOM( disp_zoom[0],disp_zoom[1], 10,10, disp_center[0],disp_center[1] );
    GDSHOW( 1 );
  }

  if ( disp_2buf > 0 )
    HPLSET( "2BUF",11 );
  
}


//////
extern"C"
void
gsim_detview_( int* iview )
{
  GsimDetView( *iview );
}

