// -*- C++ -*-
//
// GsimFFuser.cc
// User-Defined variables in the Input-Card (gsim.dat)
//
// Author:  Mitsuhiro YAMAGA (yamaga@post.kek.jp)
// Created: Thu Jul 12 15:12:46 JST 2001
//
// $Id: GsimFFuser.cc,v 1.1.1.1 2002/08/13 12:48:08 kensh Exp $
//
// Revision History
//
// $Log: GsimFFuser.cc,v $
// Revision 1.1.1.1  2002/08/13 12:48:08  kensh
//
//
// Start version.
//
//
#include <iostream>
#include "ccfortran/ccfortran.h"
#include "ccfortran/G321Common.h"


//////

// GsimUserGeom.cc
extern int    DetUseFBAR[];
extern int    DetUseCBAR[];
extern int    DetUseCSIC[];
extern int    DetUseCSEG[];
extern int    DetUseCC01[];
extern int    DetUseCC02[];
extern int    DetUseCC03[];
extern int    DetUseCC04[];
extern int    DetUseCC05[];
extern int    DetUseBMCT[];
extern int    DetUseCHGV[];
// GsimUserGeom.cc
extern float  mfstep;
// Gukine.cc
extern float  MoveGenZ[];


//////
void
GsimFFuser()
{
  if ( gcflag_.ISWIT[3-1] > 0 )
    std::cerr << "GsimFFuser" << std::endl; 

  // GsimUserGeom.cc
  FFKEY( "FBAR", DetUseFBAR,    2, "INTEGER" );
  FFKEY( "CBAR", DetUseCBAR,    2, "INTEGER" );
  FFKEY( "CSIC", DetUseCSIC,    2, "INTEGER" );
  FFKEY( "CSEG", DetUseCSEG,    2, "INTEGER" );
  FFKEY( "CC01", DetUseCC01,    2, "INTEGER" );
  FFKEY( "CC02", DetUseCC02,    2, "INTEGER" );
  FFKEY( "CC03", DetUseCC03,    2, "INTEGER" );
  FFKEY( "CC04", DetUseCC04,    2, "INTEGER" );
  FFKEY( "CC05", DetUseCC05,    2, "INTEGER" );
  FFKEY( "BMCT", DetUseBMCT,    2, "INTEGER" );
  FFKEY( "CHGV", DetUseCHGV,    2, "INTEGER" );
  // GsimUserMate.cc
  FFKEY( "MFST", mfstep,        1, "REAL");
  // Gukine.cc
  FFKEY( "MVGZ", MoveGenZ,      2, "REAL");

  //
}


